VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "cfMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Private WithEvents mForm As cWidgetForm
Attribute mForm.VB_VarHelpID = -1
Private WithEvents MenuBar As cwMenuBar
Attribute MenuBar.VB_VarHelpID = -1
Private WithEvents PopUpMenu As cwMenu
Attribute PopUpMenu.VB_VarHelpID = -1

Private WithEvents ddlBundeslaender As cwDropDownList
Attribute ddlBundeslaender.VB_VarHelpID = -1
Private WithEvents ddvlBundeslaender As cwVList
Attribute ddvlBundeslaender.VB_VarHelpID = -1

Private Const FORM_WIDTH As Single = 420
Private Const FORM_HEIGHT As Single = 580

Private Sub Class_Initialize()
    Set mForm = Cairo.WidgetForms.Create( _
        vbSizable, "Kontakte", , FORM_WIDTH, FORM_HEIGHT)
    mForm.IconImageKey = "appIcn" 'Fenster-Icon
End Sub

Public Sub Show()
Dim display As cDisplay, displays As cDisplays

    Set displays = New_c.displays
    For Each display In displays
        If display.IsPrimary Then Exit For
    Next
    With mForm
        If Not display Is Nothing Then _
            .CenterOn display
        .Show
    End With

End Sub

Private Sub Class_Terminate()
    mForm.Unload
End Sub

Private Sub ddlBundeslaender_Click()
    Debug.Print ddlBundeslaender.DataSource.FieldValue(0)
    Debug.Print ddlBundeslaender.DataSource.FieldValue(1)
End Sub

Private Sub ddvlBundeslaender_OwnerDrawItem(ByVal Index As Long, CC As vbRichClient5.cCairoContext, ByVal dx As Single, ByVal dy As Single, ByVal Alpha As Single)
Dim blName As String
Dim widgetWidth As Single
Dim scrolbarWidth As Single
    widgetWidth = ddlBundeslaender.Widget.Width
    scrolbarWidth = ddvlBundeslaender.VScrollBar.Widget.Width
    blName = ddlBundeslaender.DataSource.ValueMatrix(Index, 0)
    CC.RenderSurfaceContent blName, _
        widgetWidth - scrolbarWidth - 22, 2, 15, 18
End Sub

Private Sub MenuBar_Click(ByVal CurMenuItemPath As String)
Dim i As Integer
    Select Case True
        Case CurMenuItemPath = "mnuDatei>mnuBeenden"
            mForm.Unload
        Case Left$(CurMenuItemPath, 15) = "mnuAnsicht>Skin"
            With MenuBar.DataSource.SubItemByPathKey("mnuAnsicht>Skin")
                For i = 1 To .SubItemCount
                    MenuBar.DataSource.SubItemByPathKey("mnuAnsicht>Skin>mnuSkin" & i).Checked = False
                Next i
            End With
            MenuBar.DataSource.SubItemByPathKey(CurMenuItemPath).Checked = True
            mForm.WidgetRoot.LockRefresh = True
            If CurMenuItemPath = "mnuAnsicht>Skin>mnuSkin1" Then
                Set Cairo.Theme = New_w("cThemeWin7")
            ElseIf CurMenuItemPath = "mnuAnsicht>Skin>mnuSkin2" Then
                Set Cairo.Theme = New cMyTheme
            End If
            mForm.WidgetRoot.LockRefresh = False
            
        Case Left$(CurMenuItemPath, 15) = "mnuAnsicht>Zoom"
            With MenuBar.DataSource.SubItemByPathKey("mnuAnsicht>Zoom")
                For i = 1 To .SubItemCount
                    MenuBar.DataSource.SubItemByPathKey("mnuAnsicht>Zoom>mnuZoom" & i).Checked = False
                Next i
            End With
            MenuBar.DataSource.SubItemByPathKey(CurMenuItemPath).Checked = True
            With mForm
                If CurMenuItemPath = "mnuAnsicht>Zoom>mnuZoom2" Then
                    .WidgetRoot.Zoom = 1.25
                ElseIf CurMenuItemPath = "mnuAnsicht>Zoom>mnuZoom3" Then
                    .WidgetRoot.Zoom = 1.5
                Else
                    .WidgetRoot.Zoom = 1
                End If
                .Width = FORM_WIDTH * .WidgetRoot.Zoom
                .Height = FORM_HEIGHT * .WidgetRoot.Zoom
                .CenterOn .WidgetRoot.CurrentMonitor
            End With
    End Select
End Sub

Private Sub mForm_BubblingEvent(Sender As Object, EventName As String, P1 As Variant, P2 As Variant, P3 As Variant, P4 As Variant, P5 As Variant, P6 As Variant, P7 As Variant)
    Select Case EventName
        Case "W_GotFocus"
            If Sender.Widget.Key = "fraKategorie" Then mForm.Widgets("optInteressent").Widget.SetFocus
        Case "W_Click"
            If Sender.Widget.Key = "btnAbbrechen" Then mForm.Unload
        Case "W_MouseDown"
            If P1 <> vbRightButton Then Exit Sub
            If TypeOf Sender Is cwTextBox Then PopUpMenu.InitAndShow Sender.Widget, CreatePopUpForTextBox(Sender), PopupBehaviourMousePosExpandRight
        Case "W_KeyDown"
            If P1 = 93 Then
                If TypeOf Sender Is cwTextBox Then PopUpMenu.InitAndShow Sender.Widget, CreatePopUpForTextBox(Sender), PopupBehaviourMousePosExpandRight
            End If
    End Select

End Sub

Private Sub mForm_Load()
Dim lbl As cwLabel
Dim txt As cwTextBox
Dim btn As cwButton
Dim bundeslaender As cCollection


    Set bundeslaender = New_c.Collection()
    With bundeslaender
        .Add "BW", "Baden-Wrttemberg"
        .Add "BY", "Bayern"
        .Add "BE", "Berlin"
        .Add "BB", "Brandenburg"
        .Add "HB", "Bremen"
        .Add "HH", "Hamburg"
        .Add "HE", "Hessen"
        .Add "MV", "Mecklenburg-Vorpommern"
        .Add "NI", "Niedersachsen"
        .Add "NW", "Nordrhein-Westfalen"
        .Add "RP", "Rheinland-Pfalz"
        .Add "SL", "Saarland"
        .Add "SN", "Sachsen"
        .Add "ST", "Sachsen-Anhalt"
        .Add "SH", "Schleswig-Holstein"
        .Add "TH", "Thringen"
    End With
    
    Set MenuBar = mForm.Widgets.Add(New_w("cwMenuBar"), "MenuBar", 0, 0, mForm.ScaleWidth, 25)
    Set MenuBar.DataSource = Cairo.CreateMenuItemFromJSON(MainMenuAsJSONString)

    With New cFormRaster
        .CreateRaster Left:=10, Top:=30, _
                      Rows:=15, Cols:=32, _
                      RowHeight:=40, ColWidth:=10

        mForm.Widgets.Add(New_w("cwFrame"), "fraKategorie", _
            .x(1), .y(1), 390, 55).Caption = "Kategorie"

        Set btn = mForm.Widgets.Add(New_w("cwButton"), "optInteressent", _
            .x(2), .y(1) + 20, 100, 23)
            btn.ButtonStyle = OptionBox
            btn.Caption = "Interessent"
            btn.Value = True
        Set btn = mForm.Widgets.Add(New_w("cwButton"), "optKunde", _
            .x(12), .y(1) + 20, 100, 23)
            btn.ButtonStyle = OptionBox
            btn.Caption = "Kunde"
        Set btn = mForm.Widgets.Add(New_w("cwButton"), "optLieferant", _
            .x(22), .y(1) + 20, 100, 23)
            btn.ButtonStyle = OptionBox
            btn.Caption = "Lieferant"
        Set btn = mForm.Widgets.Add(New_w("cwButton"), "optPrivat", _
            .x(32), .y(1) + 20, 100, 23)
            btn.ButtonStyle = OptionBox
            btn.Caption = "Privat"

        Set lbl = mForm.Widgets.Add(New_w("cwLabel"), "lblName", _
            .x(1), .y(3), 100, 23)
            lbl.Caption = "&Name:"
            lbl.BorderWidth = 0
        mForm.Widgets.Add(New_w("cwTextBox"), "txtName", _
            .x(20), .y(3), 200, 23).MaxLength = 50

        Set lbl = mForm.Widgets.Add(New_w("cwLabel"), "lblVorname", _
            .x(1), .y(4), 100, 23)
            lbl.Caption = "&Vorname:"
            lbl.BorderWidth = 0
        mForm.Widgets.Add(New_w("cwTextBox"), "txtVorname", _
            .x(20), .y(4), 200, 23).MaxLength = 50

        Set lbl = mForm.Widgets.Add(New_w("cwLabel"), "lblStrasse", _
            .x(1), .y(5), 100, 23)
            lbl.Caption = "&Strae:"
            lbl.BorderWidth = 0
        mForm.Widgets.Add(New_w("cwTextBox"), "txtStrae", _
            .x(20), .y(5), 200, 23).MaxLength = 50

        Set lbl = mForm.Widgets.Add(New_w("cwLabel"), "lblPlz", _
            .x(1), .y(6), 100, 23)
            lbl.Caption = "&PLZ:"
            lbl.BorderWidth = 0
        Set txt = mForm.Widgets.Add(New_w("cwTextBox"), "txtPLZ", _
            .x(20), .y(6), 50, 23)
            txt.MaxLength = 5
            txt.Filter = cfpNumber

        Set lbl = mForm.Widgets.Add(New_w("cwLabel"), "lblOrt", _
            .x(1), .y(7), 100, 23)
            lbl.Caption = "&Ort:"
            lbl.BorderWidth = 0
        mForm.Widgets.Add(New_w("cwTextBox"), "txtOrt", _
            .x(20), .y(7), 200, 23).MaxLength = 30

        Set lbl = mForm.Widgets.Add(New_w("cwLabel"), "lblBundesland", _
            .x(1), .y(8), 100, 23)
            lbl.Caption = "&Bundesland:"
            lbl.BorderWidth = 0
        Set ddlBundeslaender = mForm.Widgets.Add(New_w("cwDropDownList"), _
            "ddlBundesland", .x(20), .y(8), 200, 23)
            Set ddvlBundeslaender = ddlBundeslaender.VList
            ddvlBundeslaender.RowHeight = 22
            ddlBundeslaender.SetDataSource bundeslaender, "Bundeslnder"
            ddlBundeslaender.DataSource.Sort = "Key Asc"

        Set btn = mForm.Widgets.Add(New_w("cwButton"), "chkAktiv", _
            .x(20), .y(9), 200, 23)
            btn.ButtonStyle = CheckBox
            btn.Caption = "Aktiv"

        Set lbl = mForm.Widgets.Add(New_w("cwLabel"), "lblBemerkungen", _
            .x(1), .y(10) - 23, 100, 23)
            lbl.Caption = "B&emerkungen:"
            lbl.BorderWidth = 0
        Set txt = mForm.Widgets.Add(New_w("cwTextBox"), "txtBemerkungen", _
            .x(1), .y(10), 390, 100)
            txt.MaxLength = 512
            txt.MultiLine = True
            txt.ScrollBars = vbVertical

        Set btn = mForm.Widgets.Add(New_w("cwButton"), "btnAbbrechen", _
            .x(20), .y(13), 90, 23)
            btn.Caption = "Abbrechen"
            btn.Widget.ImageKey = "icnCancel"
        Set btn = mForm.Widgets.Add(New_w("cwButton"), "btnSpeichern", _
            .x(31), .y(13), 90, 23)
            btn.Caption = "Speichern"
            btn.Widget.ImageKey = "icnSave"

    End With
    
    Set PopUpMenu = New_w("cwMenu")
        
End Sub

Private Function MainMenuAsJSONString() As String
  With Cairo.CreateMenuItemRoot("menuBarMain", "")
    With .AddSubItem("mnuDatei", "&Datei")
        .AddSubItem "mnuBeenden", "&Beenden"
    End With
    With .AddSubItem("mnuAnsicht", "&Ansicht")
      With .AddSubItem("Zoom", "&Zoom")
          .AddSubItem "mnuZoom1", "100%", , , True
          .AddSubItem("mnuZoom2", "125%").IsCheckable = True
          .AddSubItem("mnuZoom3", "150%").IsCheckable = True
      End With
      With .AddSubItem("Skin", "&Skin")
          .AddSubItem "mnuSkin1", "Standard", , , True
          .AddSubItem("mnuSkin2", "Gendert").IsCheckable = True
      End With
    End With
    With .AddSubItem("mnuHilfe", "&Hilfe")
      .AddSubItem "mnuHilfeInhalt", "&Inhalt"
      .AddSubItem "mnuHilfeIndex", "Inde&x"
      .AddSubItem "mnuHilfeSuche", "&Suche"
      .AddSubItem "mnuHilfeSep", "-"
      .AddSubItem "mnuHilfeInfo", "Inf&o..."
    End With
    MainMenuAsJSONString = .ToJSONString
  End With
End Function

Private Sub PopUpMenu_Click(ByVal CurMenuItemPath As String)
Dim CurDSItem As cMenuItem
Dim txt As cwTextBox

    Set CurDSItem = PopUpMenu.DataSource.SubItemByPathKey(CurMenuItemPath)
    
    If InStr(CurMenuItemPath, "TxtBoxRoot") = 1 Then
      If TypeOf mForm.WidgetRoot.ActiveWidget.Object Is cwTextBox Then
        Set txt = mForm.WidgetRoot.ActiveWidget.Object
      Else
        Exit Sub
      End If
      Select Case CurDSItem.Key
        Case "puCut", "puCopy"
            New_c.Clipboard.SetText txt.SelText
            If CurDSItem.Key = "puCut" Then txt.SelText = ""
        Case "puPaste"
            txt.SelText = New_c.Clipboard.GetText
        Case "puDelete"
            txt.SelText = ""
        Case "puSelectAll"
            txt.SelStart = 0
            txt.SelLength = 10000000
      End Select
    End If
End Sub


